# Class VulkanMemoryAllocateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanMemoryAllocateInfo

All Implemented Interfaces:
  `VulkanMemoryAllocateInfoType`

public final class VulkanMemoryAllocateInfo extends Object implements VulkanMemoryAllocateInfoType

See Also:
  - "VkMemoryAllocateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanMemoryAllocateInfo.Builder`
  Builds instances of type `VulkanMemoryAllocateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanMemoryAllocateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanMemoryAllocateInfo`.
  `static VulkanMemoryAllocateInfo`
  `copyOf(VulkanMemoryAllocateInfoType instance)`
  Creates an immutable copy of a `VulkanMemoryAllocateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanMemoryAllocateInfo` that have equal attribute values.
  `Set<VulkanMemoryAllocateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `size`, `flags`, `memoryTypeIndex`.
  `VulkanMemoryTypeIndex`
  `memoryTypeIndex()`
  `long`
  `size()`
  `String`
  `toString()`
  Prints the immutable value `VulkanMemoryAllocateInfo` with attribute values.
  `final VulkanMemoryAllocateInfo`
  `withFlags(VulkanMemoryAllocateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanMemoryAllocateInfo`
  `withFlags(Iterable<VulkanMemoryAllocateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanMemoryAllocateInfo`
  `withMemoryTypeIndex(VulkanMemoryTypeIndex value)`
  Copy the current immutable object by setting a value for the `memoryTypeIndex` attribute.
  `final VulkanMemoryAllocateInfo`
  `withSize(long value)`
  Copy the current immutable object by setting a value for the `size` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### size

    public long size()
    Specified by:
      `size` in interface `VulkanMemoryAllocateInfoType`
    Returns:
      The size of the allocation in bytes

  - ### flags

    public Set<VulkanMemoryAllocateFlag> flags()
    Specified by:
      `flags` in interface `VulkanMemoryAllocateInfoType`
    Returns:
      The memory allocation flags

  - ### memoryTypeIndex

    public VulkanMemoryTypeIndex memoryTypeIndex()
    Specified by:
      `memoryTypeIndex` in interface `VulkanMemoryAllocateInfoType`
    Returns:
      An index identifying a memory type from the memoryTypes array of the VkPhysicalDeviceMemoryProperties structure

  - ### withSize

    public final VulkanMemoryAllocateInfo withSize(long value)
    Copy the current immutable object by setting a value for the `size` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for size
    Returns:
      A modified copy or the `this` object

  - ### withFlags

    public final VulkanMemoryAllocateInfo withFlags(VulkanMemoryAllocateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanMemoryAllocateInfo withFlags(Iterable<VulkanMemoryAllocateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withMemoryTypeIndex

    public final VulkanMemoryAllocateInfo withMemoryTypeIndex(VulkanMemoryTypeIndex value)
    Copy the current immutable object by setting a value for the `memoryTypeIndex` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for memoryTypeIndex
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanMemoryAllocateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `size`, `flags`, `memoryTypeIndex`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanMemoryAllocateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanMemoryAllocateInfo copyOf(VulkanMemoryAllocateInfoType instance)
    Creates an immutable copy of a `VulkanMemoryAllocateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanMemoryAllocateInfo instance

  - ### builder

    public static VulkanMemoryAllocateInfo.Builder builder()
    Creates a builder for `VulkanMemoryAllocateInfo`.

        VulkanMemoryAllocateInfo.builder()
           .setSize(long) // optional size
           .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanMemoryAllocateFlag) // flags elements
           .setMemoryTypeIndex(com.io7m.jcoronado.api.VulkanMemoryTypeIndex) // required memoryTypeIndex
           .build();

    Returns:
      A new VulkanMemoryAllocateInfo builder